FLIEGE      = 0         ; fleiige Fliege
MACDISC     = 1         ; fleiige Scheibe
;=========================================================================


ARROW       = 0
TEXT_CRSR   = 1
HOURGLASS   = 2
POINT_HAND  = 3
FLAT_HAND   = 4
THIN_CROSS  = 5
THICK_CROSS = 6
OUTLN_CROSS = 7
USER_DEF    = 255
M_OFF       = 256
M_ON        = 257

SPEED       = 20

macro               xbra
                    dc.l    "XBRABUSY"
                    endm



start:              bra     install

                    xbra
oldgem:             dc.l    0
newgem:             tst.b   timerinst               ; beim ersten
                    bne     timerok                 ; GEM-Aufruf (AES oder VDI)
                    move.l  $114.w,oldtimer         ; eigene Timerroutine
                    move.l  #newtimer,$114.w        ; einhngen
                    movem.l d0-d2/a0-a2,-(a7)       ; und LINEA
                    aline   $0                      ; initialisieren
                    move.l  a0,line_a_vars
                    movem.l (a7)+,d0-d2/a0-a2
                    st      timerinst               ; (nie wieder aufrufen)
                    ;
timerok:            cmpi    #$c8,d0                 ; AES ?
                    bne     sgemret                 ;   nein, VDI ->
                    movem.l a0/a1,-(a7)
                    movea.l d1,a0                   ; <- ja
                    movea.l (a0),a1
                    cmpi    #78,(a1)                ; graf_mouse ?
                    bne     gemret                  ;   nein ->
                    movea.l 8(a0),a1                ; <- ja
                    cmpi    #HOURGLASS,(a1)         ; HOURGLASS
                    seq     mouseflag               ; flag setzen, sonst lschen
                    bne     gemret
                    move    #USER_DEF,(a1)          ; und durch USER_DEF
ok:                 movea.l 16(a0),a1               ; ersetzen;
                    move.l  #pic0,(a1)              ; mit Fliege No. 0
                    clr     picpos                  ; beginnen
gemret:             movem.l (a7)+,a0/a1
sgemret:            move.l  oldgem(pc),-(a7)        ; zur Originalroutine
                    rts                             ; springen



                    xbra
oldtimer:           dc.l    0
newtimer:           tst.b   mouseflag               ; 200 mal in der Sekunde
                    beq     timerexit
                    movem.l d0/a0-a2,-(a7)
                    lea     timercounter(pc),a0
                    addq    #1,(a0)         ; if (++timercounter != SPEED)
                    cmpi    #SPEED,(a0)     ;       return;
                    bne     timercont       ; timercounter = 0;
                    clr     (a0)
                    ;
                    lea     picpos(pc),a0
                    addq    #1,(a0)
                    move    (a0),d0
                    andi    #$3,d0
                    add     d0,d0
                    add     d0,d0
                    lea     mousepics(pc),a0
                    move.l  0(a0,d0.w),a0   ; a0 = &pic[++picpos];
                    ;                       ;       (nchste Fliege)
                    movea.l line_a_vars(pc),a1
                    lea     -$358(a1),a2
                    move.l  (a0)+,(a2)+
                    move.l  (a0)+,(a2)+
                    move    (a0)+,(a2)+
                    move    #15,d0
copydata:           move    (a0)+,(a2)+
                    move    30(a0),(a2)+
                    dbf     d0,copydata
                    ;
                    lea     -$158(a1),a2
                    move    sr,d0
                    ori     #$0700,sr
                    move.l  -$25a(a1),(a2)+
                    bset    #0,(a2)
                    move    d0,sr
                    ;
timercont:          movem.l (a7)+,d0/a0-a2
timerexit:          move.l  oldtimer(pc),-(a7)
                    rts



line_a_vars:        dc.l    0       ; Adresse der Line-A-Variablen
timercounter:       dc.w    0       ; 'Frequenzteiler'-speicher

timerinst:          dc.b    0       ; ist Timer bereits installiert?
mouseflag:          dc.b    0       ; Mausbild laufend ndern?

                    EVEN
picpos:             dc.w    0       ; Index des zuletzt gezeichneten Bildes
intinsave:          dc.l    0
mousepics:          dc.l    pic0, pic1, pic2, pic3



IFNE FLIEGE
pic0:               dc.w    4, 4, 1, 0, 1
                    ; Fliegenmaske
                    dc.w    $0000,$0800,$3C00,$3E00,$7F80,$3E40,$1FA0,$0BD0
                    dc.w    $0BF8,$05FC,$02FA,$01FD,$01F8,$0095,$0040,$0018
                    ; Fliegendaten
                    dc.w    $0080,$2908,$7D30,$2A40,$7F80,$2E70,$FFAC,$0BD3
                    dc.w    $0BF8,$15BC,$16DA,$15FD,$15F8,$2895,$0840,$1018

pic1:               dc.w    4, 4, 1, 0, 1
                    ; Fliegenmaske
                    dc.w    $0000,$0800,$3C00,$3E00,$7F80,$3E40,$1FA0,$0BD0
                    dc.w    $0BF8,$05FC,$02FA,$01FD,$01F8,$0095,$0040,$0018
                    ; Fliegendaten
                    dc.w    $0100,$2904,$7D08,$2A70,$7F80,$2E78,$1FA7,$EBD0
                    dc.w    $0BF8,$15BC,$16DA,$15FD,$25F8,$4295,$0240,$0218

pic2:               dc.w    4, 4, 1, 0, 1
                    ; Fliegenmaske
                    dc.w    $0000,$0800,$3C00,$3E00,$7F80,$3E40,$1FA0,$0BD0
                    dc.w    $0BF8,$05FC,$02FA,$01FD,$01F8,$0095,$0040,$0018
                    ; Fliegendaten
                    dc.w    $0200,$6A00,$7E04,$2A79,$7F86,$2E78,$1FA0,$6BD0
                    dc.w    $8BF8,$15BC,$26DA,$25FD,$43F8,$0295,$0140,$0118

pic3:               dc.w    4, 4, 1, 0, 1
                    ; Fliegenmaske
                    dc.w    $0000,$0800,$3C00,$3E00,$7F80,$3E40,$1FA0,$0BD0
                    dc.w    $0BF8,$05FC,$02FA,$01FD,$01F8,$0095,$0040,$0018
                    ; Fliegendaten
                    dc.w    $0100,$0904,$3D08,$2A70,$7F80,$2E78,$1FA7,$EBD0
                    dc.w    $0BF8,$15BC,$16DA,$15FD,$25F8,$4295,$0240,$0218
ENDIF

IFNE MACDISC
pic0:               dc.w    7, 7, 1, 0, 1
                    ; Maske
                    dc.w    $07C0,$1FF0,$3FF8,$7FFC,$7FFC,$FFFE,$FFFE,$FFFE
                    dc.w    $FFFE,$FFFE,$7FFC,$7FFC,$3FF8,$1FF0,$07C0,$0000
                    ; Daten
                    dc.w    $07C0,$1FF0,$3FF8,$5FF4,$4FE4,$87C2,$8382,$8102
                    dc.w    $8382,$87C2,$4FE4,$5FF4,$3FF8,$1FF0,$07C0,$0000
                    
pic1:               dc.w    7, 7, 1, 0, 1
                    ; Maske
                    dc.w    $07C0,$1FF0,$3FF8,$7FFC,$7FFC,$FFFE,$FFFE,$FFFE
                    dc.w    $FFFE,$FFFE,$7FFC,$7FFC,$3FF8,$1FF0,$07C0,$0000
                    ; Daten
                    dc.w    $07C0,$19F0,$21F8,$41FC,$41FC,$81FE,$81FE,$FFFE
                    dc.w    $FF02,$FF02,$7F04,$7F04,$3F08,$1F30,$07C0,$0000
                    
pic2:               dc.w    7, 7, 1, 0, 1
                    ; Maske
                    dc.w    $07C0,$1FF0,$3FF8,$7FFC,$7FFC,$FFFE,$FFFE,$FFFE
                    dc.w    $FFFE,$FFFE,$7FFC,$7FFC,$3FF8,$1FF0,$07C0,$0000
                    ; Daten
                    dc.w    $07C0,$1830,$2008,$701C,$783C,$FC7E,$FEFE,$FFFE
                    dc.w    $FEFE,$FC7E,$783C,$701C,$2008,$1830,$07C0,$0000
                    
pic3:               dc.w    7, 7, 1, 0, 1
                    ; Maske
                    dc.w    $07C0,$1FF0,$3FF8,$7FFC,$7FFC,$FFFE,$FFFE,$FFFE
                    dc.w    $FFFE,$FFFE,$7FFC,$7FFC,$3FF8,$1FF0,$07C0,$0000
                    ; Daten
                    dc.w    $07C0,$1F30,$3F08,$7F04,$7F04,$FF02,$FF02,$FFFE
                    dc.w    $81FE,$81FE,$41FC,$41FC,$21F8,$19F0,$07C0,$0000
ENDIF


                    EVEN                
end_res:            ;

;===========================================================================

install:            move.l  4(a7),a3
                    movea.l 12(a3),a0
                    adda.l  20(a3),a0
                    adda.l  28(a3),a0
                    adda.w  #$200,a0

                    move.l  a3,d0
                    add.l   a0,d0
                    and.b   #$fc,d0
                    movea.l d0,a7
                    
                    move.l  d0,-(a7)
                    move.l  a3,-(a7)
                    clr     -(a7)
                    move    #74,-(a7)
                    trap    #1

                    lea     name,a0
                    jsr     puts(pc)

                    pea     get_p_cookie
                    move    #$26,-(a7)
                    trap    #14
                    addq.l  #6,a7 
                    movea.l d0,a0
                    
test_next_cookie:   tst.l   (a0)
                    beq     no_agem_error
                    cmpi.l  #"AGEM",(a0)
                    beq     agem_cookie_found
                    addq.l  #8,a0
                    bra     test_next_cookie
                    
agem_cookie_found:  movea.l 4(a0),a0
                    cmpi.l  #"AGEM",(a0)
                    bne     magic_error
                    
                    movea.l 4(a0),a0
                    move.l  (a0),oldgem
                    move.l  #newgem,(a0)

                    lea     installed,a0
                    jsr     puts(pc)
                    
                    clr     -(a7)
                    move.l  #(end_res - start + 256),-(a7)
                    move    #49,-(a7)
                    trap    #1



get_p_cookie:       move.l  $5a0.w,d0
                    rts
                    
no_agem_error:      lea     not_installed,a0
                    jsr     puts(pc)
                    lea     no_agem_text,a0
                    jsr     puts(pc)
                    bra     error_exit

magic_error:        lea     not_installed,a0
                    jsr     puts(pc)
                    lea     illegal_magic_text,a0
                    jsr     puts(pc)
error_exit:         clr     -(a7)
                    trap    #1

puts:               pea     (a0)
                    move.w  #9,-(a7)
                    trap    #1
                    addq.l  #6,a7
                    rts




                    DATA
name:               dc.b    "Busy"
IFNE FLIEGE
                    dc.b    "Fly"
ENDIF
IFNE MACDISC
                    dc.b    "Disc"
ENDIF
                    dc.b    " V1.0 ",0

installed:          dc.b    "installed",13,10,0
not_installed:      dc.b    "not installed ",0
no_agem_text:       dc.b    "illegal AGEM-cookie",13,10,0
illegal_magic_text: dc.b    "no AGEM-cookie found",13,10,0
                    END
                    
             

